﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Media;
using System.Windows.Controls;
using Infragistics.Controls.Charts;

namespace XamDataChart_Demo
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //sa-
            PathGeometry pathGeometry = new PathGeometry();
            pathGeometry.FillRule = FillRule.Nonzero;

            PathFigure pathFigure = new PathFigure();
            pathFigure.StartPoint = new Point(4, 5);
            pathFigure.IsClosed = true;
            pathGeometry.Figures.Add(pathFigure);

            LineSegment lineSegment1 = new LineSegment();
            lineSegment1.Point = new System.Windows.Point(8, 5);
            pathFigure.Segments.Add(lineSegment1);

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Random rand = new Random();

            ObservableCollection<SimpleDataPoint> list = new ObservableCollection<SimpleDataPoint>();
            list.Add(new SimpleDataPoint() { Label = "1", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "2", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "3", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "4", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "5", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "6", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "7", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "8", Value = rand.Next(-7, 7) });
            list.Add(new SimpleDataPoint() { Label = "9", Value = rand.Next(-7, 7) });

            this.xmDataChart.DataContext = list;
            this.xmDataChart.UpdateLayout();
        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            NumericYAxis axis = this.xmColumnYAxis2 as NumericYAxis;
            if (axis == null)
                return;

            Slider slider = e.OriginalSource as Slider;
            if (slider.Name == this.slider1.Name)
            {
                axis.MinimumValue = slider.Value;
            }
            else
            if (slider.Name == this.slider2.Name)
            {
                axis.MaximumValue = slider.Value;
            }
        }
    }

    public class SimpleDataCollection : ObservableCollection<SimpleDataPoint>
    {
        public SimpleDataCollection()
        {
            this.Add(new SimpleDataPoint() { Label = "1", Value = -3.0 });
            this.Add(new SimpleDataPoint() { Label = "2", Value = 2.0 });
            this.Add(new SimpleDataPoint() { Label = "3", Value = 8.0 });
            this.Add(new SimpleDataPoint() { Label = "4", Value = -4.0 });
            this.Add(new SimpleDataPoint() { Label = "5", Value = 8.0 });
            this.Add(new SimpleDataPoint() { Label = "6", Value = 6.0 });
            this.Add(new SimpleDataPoint() { Label = "7", Value = -5.0 });
            this.Add(new SimpleDataPoint() { Label = "8", Value = 1.0 });
            this.Add(new SimpleDataPoint() { Label = "9", Value = 7.0 });
        }
    }

    public class LineDataCollection : ObservableCollection<LineData>
    {
        public LineDataCollection()
        {
            this.Add(new LineData() { ValueX = 0, ValueY = 0 });
            this.Add(new LineData() { ValueX = 9, ValueY = 0 });
        }

        public LineDataCollection(double x1, double y1, double x2, double y2)
        {
            this.Add(new LineData() { ValueX = x1, ValueY = y1 });
            this.Add(new LineData() { ValueX = x2, ValueY = y2 });
        }
    }

    public class SimpleDataPoint
    {
        public double Value { get; set; }
        public string Label { get; set; }
    }


    public class LineData
    {
        public double ValueX { get; set; }
        public double ValueY { get; set; }
    }
}
